!===============================================================================
! Copyright 2010-2016 Intel Corporation All Rights Reserved.
!
! The source code,  information  and material  ("Material") contained  herein is
! owned by Intel Corporation or its  suppliers or licensors,  and  title to such
! Material remains with Intel  Corporation or its  suppliers or  licensors.  The
! Material  contains  proprietary  information  of  Intel or  its suppliers  and
! licensors.  The Material is protected by  worldwide copyright  laws and treaty
! provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
! modified, published,  uploaded, posted, transmitted,  distributed or disclosed
! in any way without Intel's prior express written permission.  No license under
! any patent,  copyright or other  intellectual property rights  in the Material
! is granted to  or  conferred  upon  you,  either   expressly,  by implication,
! inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
! property rights must be express and approved by Intel in writing.
!
! Unless otherwise agreed by Intel in writing,  you may not remove or alter this
! notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
! suppliers or licensors in any way.
!===============================================================================

!  Content:
!      C I M A T C O P Y  Example Program Text
!*******************************************************************************
    program  CIMATCOPY_MAIN
    include 'mkl_trans.fi' 

    integer :: i, j
!   source matrix 
    complex, dimension(3,4) :: A  = RESHAPE(&
                                              &(/(1.0, 1.0), (5.0, 5.0), ( 9.0,  9.0),&  
                                                &(2.0, 2.0), (6.0, 6.0), (10.0, 10.0),& 
                                                &(3.0, 3.0), (7.0, 7.0), (11.0, 11.0),&
                                                &(4.0, 4.0), (8.0, 8.0), (12.0, 12.0) /),SHAPE(A))
    complex :: alpha = (1.0, 0.0)

!   Executable Statements
    print*, ' Example of using mkl_cimatcopy transposition '
    print*, ' INPUT DATA: '
    print*, ' Source matrix: '
    
!   print source matrix           
    do i= 1, 3
          print 102, ( A(i, j), j=1, 4)
    enddo
      
! 
!   Submatrix(3, 2) is transposed     
!
    call MKL_CIMATCOPY('C',    & ! column-major ordering
                      &'T',    & ! AB is transposed
                      & 3,     & ! rows of destination matrix
                      & 2,     & ! cols of destination matrix
                      & alpha, & ! alpha
                      & A,     & ! source matrix
                      & 3,     & ! src_lda
                      & 3 )      ! dst_lda
!   New matrix: A =  
!  ( (1.0, 1.0),  (5.0, 5.0), ( 9.0,  9.0), (4.0, 4.0),
!    (2.0, 2.0),  (6.0, 6.0), (10.0, 10.0), (8.0, 8.0),
!    (9.0, 9.0),  (10.0,10.0),(11.0, 11.0), (12.0, 12.0)
!   )          
    print*, 'OUTPUT DATA: '
    print*, 'Destination matrix : '
    print*, 'submatrix(3,2) is transposed'
      
!   print destination matrix      
    do i= 1, 3
          print 102,  ( A(i, j), j = 1, 4)
    enddo

102 format(9x,10(f6.2,',',f6.2,'i',3x))
        
    stop
    end        
