!===============================================================================
! Copyright 2010-2016 Intel Corporation All Rights Reserved.
!
! The source code,  information  and material  ("Material") contained  herein is
! owned by Intel Corporation or its  suppliers or licensors,  and  title to such
! Material remains with Intel  Corporation or its  suppliers or  licensors.  The
! Material  contains  proprietary  information  of  Intel or  its suppliers  and
! licensors.  The Material is protected by  worldwide copyright  laws and treaty
! provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
! modified, published,  uploaded, posted, transmitted,  distributed or disclosed
! in any way without Intel's prior express written permission.  No license under
! any patent,  copyright or other  intellectual property rights  in the Material
! is granted to  or  conferred  upon  you,  either   expressly,  by implication,
! inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
! property rights must be express and approved by Intel in writing.
!
! Unless otherwise agreed by Intel in writing,  you may not remove or alter this
! notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
! suppliers or licensors in any way.
!===============================================================================

!  Content:
!      S O M A T C O P Y  Example Program Text
!*******************************************************************************
    program  SOMATCOPY_MAIN
    include 'mkl_trans.fi' 

    integer :: i, j
!   source matrix
    real, dimension(3,5), parameter :: A = real(RESHAPE(&
                                          &(/1, 6, 11,&  
                                            &2, 7, 12,& 
                                            &3, 8, 13,&
                                            &4, 9, 14,&
                                            &5, 10,15/),SHAPE(A)))
    real,dimension(4,2) :: B ! destination matrix 

!   Executable Statements
    print*, ' Example of using mkl_somatcopy transposition '
    print*, ' INPUT DATA: '
    print*, ' Source matrix: '    
!   print source matrix           
    do i= 1, 3
          print 102, ( A(i, j), j=1, 5)
    enddo      
! 
!   Submatrix(2, 4) is transposed     
!
    call MKL_SOMATCOPY('C', & ! column-major ordering
                      &'T', & ! A is transposed
                      & 2,  & ! rows of destination matrix
                      & 4,  & ! cols of destination matrix
                      & 1.0,& ! alpha
                      & A,  & ! source matrix
                      & 3,  & ! lda
                      & B,  & ! destination matrix
                      & 4 )   ! ldb
!   New matrix: B =  
!  ( 1.0,  6.0,
!    2.0,  7.0,
!    3.0,  8.0,
!    4.0,  9.0
!   )
    print*, 'OUTPUT DATA: '
    print*, 'Destination matrix: '
    print*, 'Submatrix(2,4) is transposed'
      
!   print destination matrix      
    do i= 1, 4
          print 102,  ( B(i, j), j = 1, 2)
    enddo
    
102 format(9x,10(f8.3,2x))
    
    stop
    end
