!===============================================================================
! Copyright 2010-2016 Intel Corporation All Rights Reserved.
!
! The source code,  information  and material  ("Material") contained  herein is
! owned by Intel Corporation or its  suppliers or licensors,  and  title to such
! Material remains with Intel  Corporation or its  suppliers or  licensors.  The
! Material  contains  proprietary  information  of  Intel or  its suppliers  and
! licensors.  The Material is protected by  worldwide copyright  laws and treaty
! provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
! modified, published,  uploaded, posted, transmitted,  distributed or disclosed
! in any way without Intel's prior express written permission.  No license under
! any patent,  copyright or other  intellectual property rights  in the Material
! is granted to  or  conferred  upon  you,  either   expressly,  by implication,
! inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
! property rights must be express and approved by Intel in writing.
!
! Unless otherwise agreed by Intel in writing,  you may not remove or alter this
! notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
! suppliers or licensors in any way.
!===============================================================================

!  Content:
!      Z O M A T C O P Y  Example Program Text
!*******************************************************************************
    program  ZOMATCOPY_MAIN
    include 'mkl_trans.fi' 

    integer :: i, j
!   source matrix 
    double complex,dimension(3,5),parameter :: A=RESHAPE(&
                                                &(/(1.0,1.0), ( 6.0, 6.0), (11.0, 11.0),&  
                                                  &(2.0,2.0), ( 7.0, 7.0), (12.0, 12.0),& 
                                                  &(3.0,3.0), ( 8.0, 8.0), (13.0, 13.0),&
                                                  &(4.0,4.0), ( 9.0, 9.0), (14.0, 14.0),&
                                                  &(5.0,5.0), (10.0,10.0), (15.0, 15.0)/),SHAPE(A))
    double complex, dimension(4,2) :: B   ! destination matrix 
    double complex ::  alpha = 1.0

!   Executable Statements
    print*, ' Example of using mkl_zomatcopy transposition '
    print*, ' INPUT DATA: '
    print*, ' Source matrix: '    
!   print source matrix           
    do i= 1, 3
          print 102, ( A(i, j), j=1, 5)
    enddo      
! 
!   Submatrix(2, 4) is transposed     
!
    call MKL_ZOMATCOPY('C',    & ! column-major ordering
                      &'T',    & ! A is transposed
                      & 2,     & ! rows of destination matrix
                      & 4,     & ! cols of destination matrix
                      & alpha, & ! alpha
                      & A,     & ! source matrix
                      & 3,     & ! lda
                      & B,     & ! destination matrix
                      & 4 )      ! ldb
!   New matrix: B =  
!  ( (1.0, 1.0),  (6.0, 6.0),
!    (2.0, 2.0),  (7.0, 7.0),
!    (3.0, 3.0),  (8.0, 8.0),
!    (4.0, 4.0),  (9.0, 9.0)
!   )
!   print source matrix           
    print*, 'OUTPUT DATA: '
    print*, 'Destination matrix: '
    print*, 'Submatrix(2,4) is transposed'
    do i= 1, 4
          print 102, ( B(i, j), j=1, 2)
    enddo
! 
!   Submatrix(3,4) is conjugate transposed     
!
    call MKL_ZOMATCOPY('C',    & ! column-major ordering
                      &'C',    & ! A is conjugate transposed
                      & 2,     & ! rows of destination matrix
                      & 4,     & ! cols of destination matrix
                      & alpha, & ! alpha
                      & A,     & ! source matrix
                      & 3,     & ! lda
                      & B,     & ! destination matrix
                      & 4 )      ! ldb
!   New matrix: B =  
!  ( (1.0, -1.0),  (6.0, -6.0),
!    (2.0, -2.0),  (7.0, -7.0),
!    (3.0, -3.0),  (8.0, -8.0),
!    (4.0, -4.0),  (9.0, -9.0)
!   )      
!   print destination matrix      
    print*, 'Destination matrix: '
    print*, 'Submatrix(3,4) is conjugate transposed'
    do i= 1, 4
          print 102,  ( B(i, j), j = 1, 2)
    enddo    
    
102 format(9x,10(f6.2,',',f6.2,'i',3x))

    stop
    end
