!===============================================================================
! Copyright 2001-2016 Intel Corporation All Rights Reserved.
!
! The source code,  information  and material  ("Material") contained  herein is
! owned by Intel Corporation or its  suppliers or licensors,  and  title to such
! Material remains with Intel  Corporation or its  suppliers or  licensors.  The
! Material  contains  proprietary  information  of  Intel or  its suppliers  and
! licensors.  The Material is protected by  worldwide copyright  laws and treaty
! provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
! modified, published,  uploaded, posted, transmitted,  distributed or disclosed
! in any way without Intel's prior express written permission.  No license under
! any patent,  copyright or other  intellectual property rights  in the Material
! is granted to  or  conferred  upon  you,  either   expressly,  by implication,
! inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
! property rights must be express and approved by Intel in writing.
!
! Unless otherwise agreed by Intel in writing,  you may not remove or alter this
! notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
! suppliers or licensors in any way.
!===============================================================================

!  Content:
!    vmlSetMode/vmlGetMode  Example Program Text
!*******************************************************************************

      program MKL_VML_TEST

      include "mkl_vml.f90"

      integer mode
      integer tmode

      mode=0

      print *,"vmlSetMode/vmlGetMode example program"
      print *,""
      print *,""

      mode=VMLGETMODE()
      print 10,"Default value of vmlMode: ",mode,"h"
      call PrintTextVmlMode(mode)

      mode=IOR(VML_LA,IOR(VML_FLOAT_CONSISTENT,VML_ERRMODE_IGNORE))
      tmode=VMLSETMODE(mode)
      mode=VMLGETMODE()
      print 10,"Value of vmlMode after using vmlSetMode: ",mode,"h"
      call PrintTextVmlMode(mode)

10    format(A,Z4,A)

      end


      subroutine PrintTextVmlMode(mode)

      include "mkl_vml.f90"

      integer(kind=4) mode
      integer(kind=4) mask

      mask=VML_ACCURACY_MASK
      if(IAND(mode,mask).eq.1) print *,"VML_LA"
      if(IAND(mode,mask).eq.2) print *,"VML_HA"

      mask=VML_FPUMODE_MASK
      if(IAND(mode,mask).eq.0) print *,"VML_DEFAULT_PRECISION"
      if(IAND(mode,mask).eq.16) print *,"VML_FLOAT_CONSISTENT "
      if(IAND(mode,mask).eq.32) print *,"VML_DOUBLE_CONSISTENT"
      if(IAND(mode,mask).eq.48) print *,"VML_RESTORE"

      mask=VML_ERRMODE_MASK
      if(IAND(mode,VML_ERRMODE_IGNORE).eq.VML_ERRMODE_IGNORE)           &
     &  print *,"VML_ERRMODE_IGNORE"
      if(IAND(mode,VML_ERRMODE_ERRNO).eq.VML_ERRMODE_ERRNO)             &
     &  print *,"VML_ERRMODE_ERRNO"
      if(IAND(mode,VML_ERRMODE_STDERR).eq.VML_ERRMODE_STDERR)           &
     &  print *,"VML_ERRMODE_STDERR"
      if(IAND(mode,VML_ERRMODE_EXCEPT).eq.VML_ERRMODE_EXCEPT)           &
     &  print *,"VML_ERRMODE_EXCEPT"
      if(IAND(mode,VML_ERRMODE_CALLBACK).eq.VML_ERRMODE_CALLBACK)       &
     &  print *,"VML_ERRMODE_CALLBACK"

      end
