!===============================================================================
! Copyright 2001-2016 Intel Corporation All Rights Reserved.
!
! The source code,  information  and material  ("Material") contained  herein is
! owned by Intel Corporation or its  suppliers or licensors,  and  title to such
! Material remains with Intel  Corporation or its  suppliers or  licensors.  The
! Material  contains  proprietary  information  of  Intel or  its suppliers  and
! licensors.  The Material is protected by  worldwide copyright  laws and treaty
! provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
! modified, published,  uploaded, posted, transmitted,  distributed or disclosed
! in any way without Intel's prior express written permission.  No license under
! any patent,  copyright or other  intellectual property rights  in the Material
! is granted to  or  conferred  upon  you,  either   expressly,  by implication,
! inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
! property rights must be express and approved by Intel in writing.
!
! Unless otherwise agreed by Intel in writing,  you may not remove or alter this
! notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
! suppliers or licensors in any way.
!===============================================================================

!  Content:
!    vcAbs  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.f90"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      complex(kind=4) cA(10)
      real(kind=4) fB(10)
      real(kind=4) fBha0(10)
      real(kind=4) fBha1(10)
      real(kind=4) fBha2(10)
      real(kind=4) fBla1(10)
      real(kind=4) fBla2(10)
      real(kind=4) fBep1(10)
      real(kind=4) fBep2(10)
      real(kind=4) CurRMS,MaxRMS

      integer(kind=8) mode
      integer tmode
      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      cA( 1)=(-1000.0000,1000.0000)
      cA( 2)=(-777.7777,777.7777)
      cA( 3)=(-555.5555,555.5555)
      cA( 4)=(-333.3333,333.3333)
      cA( 5)=(-111.1111,111.1111)
      cA( 6)=(111.1111,-111.1111)
      cA( 7)=(333.3333,-333.3333)
      cA( 8)=(555.5555,-555.5555)
      cA( 9)=(777.7777,-777.7777)
      cA(10)=(1000.0000,-1000.0000)
      fB( 1)=1.4142135623730951e+003
      fB( 2)=1.0999437859382454e+003
      fB( 3)=7.8567409582014136e+002
      fB( 4)=4.7140449201878312e+002
      fB( 5)=1.5713482347986556e+002
      fB( 6)=1.5713482347986556e+002
      fB( 7)=4.7140449201878312e+002
      fB( 8)=7.8567409582014136e+002
      fB( 9)=1.0999437859382454e+003
      fB(10)=1.4142135623730951e+003

      call VCABS(vec_len,cA,fBha0)

      mode=VML_EP
      call VMCABS(vec_len,cA,fBep1,mode)

      tmode=VML_EP
      tmode=VMLSETMODE(tmode)
      call VCABS(vec_len,cA,fBep2)

      mode=VML_LA
      call VMCABS(vec_len,cA,fBla1,mode)

      tmode=VML_LA
      tmode=VMLSETMODE(tmode)
      call VCABS(vec_len,cA,fBla2)

      mode=VML_HA
      call VMCABS(vec_len,cA,fBha1,mode)

      tmode=VML_HA
      tmode=VMLSETMODE(tmode)
      call VCABS(vec_len,cA,fBha2)

      do i=1,10
          if(fBha0(i) .ne. fBha1(i)) then
              print *,"Error! Difference between VCABS and"
              print *," VMCABS in VML_HA mode detected"
              stop 1
          endif
          if(fBha1(i) .ne. fBha2(i)) then
              print *,"Error! Difference between VCABS and"
              print *," VMCABS in VML_HA mode detected"
              stop 1
          endif
          if(fBla1(i) .ne. fBla2(i)) then
              print *,"Error! Difference between VCABS and"
              print *," VMCABS in VML_LA mode detected"
              stop 1
          endif
          if(fBep1(i) .ne. fBep2(i)) then
              print *,"Error! Difference between VCABS and"
              print *," VMCABS in VML_EP mode detected"
              stop 1
          endif
      end do

      print *,"vcAbs test/example program"
      print *,""
      print *,"           Argument                     vcAbs"
      print *,"======================================================", &
     &        "========================"
      do i=1,vec_len
            print 10,cA(i),"    ",fBha0(i)
            CurRMS=srelerr(fB(i),fBha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E15.7,E15.7,A5,E15.7)
11    format(A,F25.16)

      end
