!===============================================================================
! Copyright 2001-2016 Intel Corporation All Rights Reserved.
!
! The source code,  information  and material  ("Material") contained  herein is
! owned by Intel Corporation or its  suppliers or licensors,  and  title to such
! Material remains with Intel  Corporation or its  suppliers or  licensors.  The
! Material  contains  proprietary  information  of  Intel or  its suppliers  and
! licensors.  The Material is protected by  worldwide copyright  laws and treaty
! provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
! modified, published,  uploaded, posted, transmitted,  distributed or disclosed
! in any way without Intel's prior express written permission.  No license under
! any patent,  copyright or other  intellectual property rights  in the Material
! is granted to  or  conferred  upon  you,  either   expressly,  by implication,
! inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
! property rights must be express and approved by Intel in writing.
!
! Unless otherwise agreed by Intel in writing,  you may not remove or alter this
! notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
! suppliers or licensors in any way.
!===============================================================================

!  Content:
!    vcAdd  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.f90"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      complex(kind=4) cA(10)
      complex(kind=4) cB(10)
      complex(kind=4) cBha0(10)
      complex(kind=4) cBha1(10)
      complex(kind=4) cBha2(10)
      complex(kind=4) cBla1(10)
      complex(kind=4) cBla2(10)
      complex(kind=4) cBep1(10)
      complex(kind=4) cBep2(10)

      real(kind=4) CurRMS,MaxRMS

      integer(kind=8) mode
      integer tmode
      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      cA( 1)=(-10000.0000,10000.0000)
      cA( 2)=(-7777.7778,7777.7778)
      cA( 3)=(-5555.5557,5555.5557)
      cA( 4)=(-3333.3333,3333.3333)
      cA( 5)=(-1111.1111,1111.1111)
      cA( 6)=(1111.1111,-1111.1111)
      cA( 7)=(3333.3333,-3333.3333)
      cA( 8)=(5555.5557,-5555.5557)
      cA( 9)=(7777.7778,-7777.7778)
      cA(10)=(10000.0000,-10000.0000)
      cB( 1)=(-2.0000000000000000e+004,2.0000000000000000e+004)
      cB( 2)=(-1.5555555664062500e+004,1.5555555664062500e+004)
      cB( 3)=(-1.1111111328125000e+004,1.1111111328125000e+004)
      cB( 4)=(-6.6666665039062500e+003,6.6666665039062500e+003)
      cB( 5)=(-2.2222221679687500e+003,2.2222221679687500e+003)
      cB( 6)=(2.2222221679687500e+003,-2.2222221679687500e+003)
      cB( 7)=(6.6666665039062500e+003,-6.6666665039062500e+003)
      cB( 8)=(1.1111111328125000e+004,-1.1111111328125000e+004)
      cB( 9)=(1.5555555664062500e+004,-1.5555555664062500e+004)
      cB(10)=(2.0000000000000000e+004,-2.0000000000000000e+004)

      call VCADD(vec_len,cA,cA,cBha0)

      mode=VML_EP
      call VMCADD(vec_len,cA,cA,cBep1,mode)

      tmode=VML_EP
      tmode=VMLSETMODE(tmode)
      call VCADD(vec_len,cA,cA,cBep2)

      mode=VML_LA
      call VMCADD(vec_len,cA,cA,cBla1,mode)

      tmode=VML_LA
      tmode=VMLSETMODE(tmode)
      call VCADD(vec_len,cA,cA,cBla2)

      mode=VML_HA
      call VMCADD(vec_len,cA,cA,cBha1,mode)

      tmode=VML_HA
      tmode=VMLSETMODE(tmode)
      call VCADD(vec_len,cA,cA,cBha2)

      do i=1,10
          if(cBha0(i) .ne. cBha1(i)) then
              print *,"Error! Difference between VCADD and"
              print *," VMCADD in VML_HA mode detected"
              stop 1
          endif
          if(cBha1(i) .ne. cBha2(i)) then
              print *,"Error! Difference between VCADD and"
              print *," VMCADD in VML_HA mode detected"
              stop 1
          endif
          if(cBla1(i) .ne. cBla2(i)) then
              print *,"Error! Difference between VCADD and"
              print *," VMCADD in VML_LA mode detected"
              stop 1
          endif
          if(cBep1(i) .ne. cBep2(i)) then
              print *,"Error! Difference between VCADD and"
              print *," VMCADD in VML_EP mode detected"
              stop 1
          endif
      end do

      print *,"vcAdd test/example program"
      print *,""
      print *,"                    Arguments                         ", &
     &        "      vcAdd"
      print *,"======================================================", &
     &        "========================"
      do i=1,vec_len
            print 10,cA(i),cA(i),"    ",cBha0(i)
            CurRMS=crelerr(cB(i),cBha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E12.3,E12.3,E12.3,E12.3,A5,E12.3,E12.3)
11    format(A,F25.16)

      end
