!===============================================================================
! Copyright 2001-2016 Intel Corporation All Rights Reserved.
!
! The source code,  information  and material  ("Material") contained  herein is
! owned by Intel Corporation or its  suppliers or licensors,  and  title to such
! Material remains with Intel  Corporation or its  suppliers or  licensors.  The
! Material  contains  proprietary  information  of  Intel or  its suppliers  and
! licensors.  The Material is protected by  worldwide copyright  laws and treaty
! provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
! modified, published,  uploaded, posted, transmitted,  distributed or disclosed
! in any way without Intel's prior express written permission.  No license under
! any patent,  copyright or other  intellectual property rights  in the Material
! is granted to  or  conferred  upon  you,  either   expressly,  by implication,
! inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
! property rights must be express and approved by Intel in writing.
!
! Unless otherwise agreed by Intel in writing,  you may not remove or alter this
! notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
! suppliers or licensors in any way.
!===============================================================================

!  Content:
!    vcAsin  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.f90"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      complex(kind=4) cA(10)
      complex(kind=4) cB(10)
      complex(kind=4) cBha0(10)
      complex(kind=4) cBha1(10)
      complex(kind=4) cBha2(10)
      complex(kind=4) cBla1(10)
      complex(kind=4) cBla2(10)
      complex(kind=4) cBep1(10)
      complex(kind=4) cBep2(10)

      real(kind=4) CurRMS,MaxRMS

      integer(kind=8) mode
      integer tmode
      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      cA( 1)=(-1.0000,1.0000)
      cA( 2)=(-0.7777,0.7777)
      cA( 3)=(-0.5555,0.5555)
      cA( 4)=(-0.3333,0.3333)
      cA( 5)=(-0.1111,0.1111)
      cA( 6)=(0.1111,-0.1111)
      cA( 7)=(0.3333,-0.3333)
      cA( 8)=(0.5555,-0.5555)
      cA( 9)=(0.7777,-0.7777)
      cA(10)=(1.0000,-1.0000)
      cB( 1)=(-6.6623943249251527e-001,1.0612750053405762e+000)
      cB( 2)=(-6.0135587974594140e-001,8.4060454368591309e-001)
      cB( 3)=(-4.8944078583553818e-001,5.9386557340621948e-001)
      cB( 4)=(-3.1990734164088330e-001,3.4427276253700256e-001)
      cB( 5)=(-1.1063789073495189e-001,1.1155195534229279e-001)
      cB( 6)=(1.1063789073495189e-001,-1.1155195534229279e-001)
      cB( 7)=(3.1990734164088330e-001,-3.4427276253700256e-001)
      cB( 8)=(4.8944078583553818e-001,-5.9386557340621948e-001)
      cB( 9)=(6.0135587974594140e-001,-8.4060454368591309e-001)
      cB(10)=(6.6623943249251527e-001,-1.0612750053405762e+000)

      call VCASIN(vec_len,cA,cBha0)

      mode=VML_EP
      call VMCASIN(vec_len,cA,cBep1,mode)

      tmode=VML_EP
      tmode=VMLSETMODE(tmode)
      call VCASIN(vec_len,cA,cBep2)

      mode=VML_LA
      call VMCASIN(vec_len,cA,cBla1,mode)

      tmode=VML_LA
      tmode=VMLSETMODE(tmode)
      call VCASIN(vec_len,cA,cBla2)

      mode=VML_HA
      call VMCASIN(vec_len,cA,cBha1,mode)

      tmode=VML_HA
      tmode=VMLSETMODE(tmode)
      call VCASIN(vec_len,cA,cBha2)

      do i=1,10
          if(cBha0(i) .ne. cBha1(i)) then
              print *,"Error! Difference between VCASIN and"
              print *," VMCASIN in VML_HA mode detected"
              stop 1
          endif
          if(cBha1(i) .ne. cBha2(i)) then
              print *,"Error! Difference between VCASIN and"
              print *," VMCASIN in VML_HA mode detected"
              stop 1
          endif
          if(cBla1(i) .ne. cBla2(i)) then
              print *,"Error! Difference between VCASIN and"
              print *," VMCASIN in VML_LA mode detected"
              stop 1
          endif
          if(cBep1(i) .ne. cBep2(i)) then
              print *,"Error! Difference between VCASIN and"
              print *," VMCASIN in VML_EP mode detected"
              stop 1
          endif
      end do

      print *,"vcAsin test/example program"
      print *,""
      print *,"           Argument                     vcAsin"
      print *,"======================================================", &
     &        "========================"
      do i=1,vec_len
            print 10,cA(i),"    ",cBha0(i)
            CurRMS=crelerr(cB(i),cBha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E15.7,E15.7,A5,E15.7,E15.7)
11    format(A,F25.16)

      end
