!===============================================================================
! Copyright 2001-2016 Intel Corporation All Rights Reserved.
!
! The source code,  information  and material  ("Material") contained  herein is
! owned by Intel Corporation or its  suppliers or licensors,  and  title to such
! Material remains with Intel  Corporation or its  suppliers or  licensors.  The
! Material  contains  proprietary  information  of  Intel or  its suppliers  and
! licensors.  The Material is protected by  worldwide copyright  laws and treaty
! provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
! modified, published,  uploaded, posted, transmitted,  distributed or disclosed
! in any way without Intel's prior express written permission.  No license under
! any patent,  copyright or other  intellectual property rights  in the Material
! is granted to  or  conferred  upon  you,  either   expressly,  by implication,
! inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
! property rights must be express and approved by Intel in writing.
!
! Unless otherwise agreed by Intel in writing,  you may not remove or alter this
! notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
! suppliers or licensors in any way.
!===============================================================================

!  Content:
!    vcAsinh  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.f90"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      complex(kind=4) cA(10)
      complex(kind=4) cB(10)
      complex(kind=4) cBha0(10)
      complex(kind=4) cBha1(10)
      complex(kind=4) cBha2(10)
      complex(kind=4) cBla1(10)
      complex(kind=4) cBla2(10)
      complex(kind=4) cBep1(10)
      complex(kind=4) cBep2(10)

      real(kind=4) CurRMS,MaxRMS

      integer(kind=8) mode
      integer tmode
      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      cA( 1)=(3.0000,10000.0000)
      cA( 2)=(1113.7777,8889.2227)
      cA( 3)=(2224.5554,7778.4443)
      cA( 4)=(3335.3333,6667.6665)
      cA( 5)=(4446.1113,5556.8887)
      cA( 6)=(5556.8887,4446.1113)
      cA( 7)=(6667.6665,3335.3333)
      cA( 8)=(7778.4443,2224.5554)
      cA( 9)=(8889.2227,1113.7777)
      cA(10)=(10000.0000,3.0000)
      cB( 1)=(9.9034875950361272e+000,1.5704963207244873e+000)
      cB( 2)=(9.7935305399540784e+000,1.4461505413055420e+000)
      cB( 3)=(9.6915674216669974e+000,1.2922420501708984e+000)
      cB( 4)=(9.6098341803762892e+000,1.1069687604904175e+000)
      cB( 5)=(9.5633416449802731e+000,8.9598953723907471e-001)
      cB( 6)=(9.5633416471460873e+000,6.7480677366256714e-001)
      cB( 7)=(9.6098341857711080e+000,4.6382755041122437e-001)
      cB( 8)=(9.6915674281509592e+000,2.7855432033538818e-001)
      cB( 9)=(9.7935305459913469e+000,1.2464573234319687e-001)
      cB(10)=(9.9034876000361258e+000,2.9999998514540493e-004)

      call VCASINH(vec_len,cA,cBha0)

      mode=VML_EP
      call VMCASINH(vec_len,cA,cBep1,mode)

      tmode=VML_EP
      tmode=VMLSETMODE(tmode)
      call VCASINH(vec_len,cA,cBep2)

      mode=VML_LA
      call VMCASINH(vec_len,cA,cBla1,mode)

      tmode=VML_LA
      tmode=VMLSETMODE(tmode)
      call VCASINH(vec_len,cA,cBla2)

      mode=VML_HA
      call VMCASINH(vec_len,cA,cBha1,mode)

      tmode=VML_HA
      tmode=VMLSETMODE(tmode)
      call VCASINH(vec_len,cA,cBha2)

      do i=1,10
          if(cBha0(i) .ne. cBha1(i)) then
              print *,"Error! Difference between VCASINH and"
              print *," VMCASINH in VML_HA mode detected"
              stop 1
          endif
          if(cBha1(i) .ne. cBha2(i)) then
              print *,"Error! Difference between VCASINH and"
              print *," VMCASINH in VML_HA mode detected"
              stop 1
          endif
          if(cBla1(i) .ne. cBla2(i)) then
              print *,"Error! Difference between VCASINH and"
              print *," VMCASINH in VML_LA mode detected"
              stop 1
          endif
          if(cBep1(i) .ne. cBep2(i)) then
              print *,"Error! Difference between VCASINH and"
              print *," VMCASINH in VML_EP mode detected"
              stop 1
          endif
      end do

      print *,"vcAsinh test/example program"
      print *,""
      print *,"           Argument                     vcAsinh"
      print *,"======================================================", &
     &        "========================"
      do i=1,vec_len
            print 10,cA(i),"    ",cBha0(i)
            CurRMS=crelerr(cB(i),cBha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E15.7,E15.7,A5,E15.7,E15.7)
11    format(A,F25.16)

      end
