!===============================================================================
! Copyright 2001-2016 Intel Corporation All Rights Reserved.
!
! The source code,  information  and material  ("Material") contained  herein is
! owned by Intel Corporation or its  suppliers or licensors,  and  title to such
! Material remains with Intel  Corporation or its  suppliers or  licensors.  The
! Material  contains  proprietary  information  of  Intel or  its suppliers  and
! licensors.  The Material is protected by  worldwide copyright  laws and treaty
! provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
! modified, published,  uploaded, posted, transmitted,  distributed or disclosed
! in any way without Intel's prior express written permission.  No license under
! any patent,  copyright or other  intellectual property rights  in the Material
! is granted to  or  conferred  upon  you,  either   expressly,  by implication,
! inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
! property rights must be express and approved by Intel in writing.
!
! Unless otherwise agreed by Intel in writing,  you may not remove or alter this
! notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
! suppliers or licensors in any way.
!===============================================================================

!  Content:
!    vcCIS  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.f90"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=4) fA(10)
      complex(kind=4) cB(10)
      complex(kind=4) cBha0(10)
      complex(kind=4) cBha1(10)
      complex(kind=4) cBha2(10)
      complex(kind=4) cBla1(10)
      complex(kind=4) cBla2(10)
      complex(kind=4) cBep1(10)
      complex(kind=4) cBep2(10)

      real(kind=4) CurRMS,MaxRMS

      integer(kind=8) mode
      integer tmode
      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      fA( 1)=-10000.0000
      fA( 2)=-7777.7777
      fA( 3)=-5555.5555
      fA( 4)=-3333.3333
      fA( 5)=-1111.1111
      fA( 6)=1111.1111
      fA( 7)=3333.3333
      fA( 8)=5555.5555
      fA( 9)=7777.7777
      fA(10)=10000.0000
      cB( 1)=(-9.5215536825901481e-001,3.0561438888825215e-001)
      cB( 2)=(6.9269429374198155e-001,7.2123131893817349e-001)
      cB( 3)=(3.4378424494653864e-001,-9.3904866376910323e-001)
      cB( 4)=(-9.9465418116759940e-001,1.0326209316981849e-001)
      cB( 5)=(5.2955928772685279e-001,8.4827292823844636e-001)
      cB( 6)=(5.2955928772685279e-001,-8.4827292823844636e-001)
      cB( 7)=(-9.9465418116759940e-001,-1.0326209316981849e-001)
      cB( 8)=(3.4378424494653864e-001,9.3904866376910323e-001)
      cB( 9)=(6.9269429374198155e-001,-7.2123131893817349e-001)
      cB(10)=(-9.5215536825901481e-001,-3.0561438888825215e-001)

      call VCCIS(vec_len,fA,cBha0)

      mode=VML_EP
      call VMCCIS(vec_len,fA,cBep1,mode)

      tmode=VML_EP
      tmode=VMLSETMODE(tmode)
      call VCCIS(vec_len,fA,cBep2)

      mode=VML_LA
      call VMCCIS(vec_len,fA,cBla1,mode)

      tmode=VML_LA
      tmode=VMLSETMODE(tmode)
      call VCCIS(vec_len,fA,cBla2)

      mode=VML_HA
      call VMCCIS(vec_len,fA,cBha1,mode)

      tmode=VML_HA
      tmode=VMLSETMODE(tmode)
      call VCCIS(vec_len,fA,cBha2)

      do i=1,10
          if(cBha0(i) .ne. cBha1(i)) then
              print *,"Error! Difference between VCCIS and"
              print *," VMCCIS in VML_HA mode detected"
              stop 1
          endif
          if(cBha1(i) .ne. cBha2(i)) then
              print *,"Error! Difference between VCCIS and"
              print *," VMCCIS in VML_HA mode detected"
              stop 1
          endif
          if(cBla1(i) .ne. cBla2(i)) then
              print *,"Error! Difference between VCCIS and"
              print *," VMCCIS in VML_LA mode detected"
              stop 1
          endif
          if(cBep1(i) .ne. cBep2(i)) then
              print *,"Error! Difference between VCCIS and"
              print *," VMCCIS in VML_EP mode detected"
              stop 1
          endif
      end do

      print *,"vcCIS test/example program"
      print *,""
      print *,"   Argument                     vcCIS"
      print *,"======================================================", &
     &        "========================"
      do i=1,vec_len
            print 10,fA(i),"    ",cBha0(i)
            CurRMS=crelerr(cB(i),cBha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E15.7,A5,E15.7,E15.7)
11    format(A,F25.16)

      end
