!===============================================================================
! Copyright 2001-2016 Intel Corporation All Rights Reserved.
!
! The source code,  information  and material  ("Material") contained  herein is
! owned by Intel Corporation or its  suppliers or licensors,  and  title to such
! Material remains with Intel  Corporation or its  suppliers or  licensors.  The
! Material  contains  proprietary  information  of  Intel or  its suppliers  and
! licensors.  The Material is protected by  worldwide copyright  laws and treaty
! provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
! modified, published,  uploaded, posted, transmitted,  distributed or disclosed
! in any way without Intel's prior express written permission.  No license under
! any patent,  copyright or other  intellectual property rights  in the Material
! is granted to  or  conferred  upon  you,  either   expressly,  by implication,
! inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
! property rights must be express and approved by Intel in writing.
!
! Unless otherwise agreed by Intel in writing,  you may not remove or alter this
! notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
! suppliers or licensors in any way.
!===============================================================================

!  Content:
!    vcPowx  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.f90"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      complex(kind=4) cA(10)
      complex(kind=4) cB(10)
      complex(kind=4) cBha0(10)
      complex(kind=4) cBha1(10)
      complex(kind=4) cBha2(10)
      complex(kind=4) cBla1(10)
      complex(kind=4) cBla2(10)
      complex(kind=4) cBep1(10)
      complex(kind=4) cBep2(10)

      real(kind=4) CurRMS,MaxRMS

      integer(kind=8) mode
      integer tmode
      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      cA( 1)=(0.1000,7.0000)
      cA( 2)=(0.8666,6.2333)
      cA( 3)=(1.6333,5.4666)
      cA( 4)=(2.4000,4.6999)
      cA( 5)=(3.1666,3.9333)
      cA( 6)=(3.9333,3.1666)
      cA( 7)=(4.7000,2.3999)
      cA( 8)=(5.4666,1.6333)
      cA( 9)=(6.2333,0.8666)
      cA(10)=(7.0000,0.0999)
      cB( 1)=(1.4660081731727082e+001,-4.2457664528605692e+000)
      cB( 2)=(6.6546281414811581e+000,-1.3285049956433053e+001)
      cB( 3)=(-7.0387482404509374e+000,-1.4767324238678261e+001)
      cB( 4)=(-2.1117849271454592e+001,-3.4930927491228259e+000)
      cB( 5)=(-2.4424384995282274e+001,2.4394003894154913e+001)
      cB( 6)=(4.1042341669135736e+000,6.8100665478272219e+001)
      cB( 7)=(1.0377464969389693e+002,1.1602925928663136e+002)
      cB( 8)=(3.5030956185511837e+002,1.3713892387072394e+002)
      cB( 9)=(8.9261612350130133e+002,7.6109263759848176e+001)
      cB(10)=(2.0121482556255414e+003,-1.3059791392822208e+002)

      call VCPOWX(vec_len,cA,cA(6),cBha0)

      mode=VML_EP
      call VMCPOWX(vec_len,cA,cA(6),cBep1,mode)

      tmode=VML_EP
      tmode=VMLSETMODE(tmode)
      call VCPOWX(vec_len,cA,cA(6),cBep2)

      mode=VML_LA
      call VMCPOWX(vec_len,cA,cA(6),cBla1,mode)

      tmode=VML_LA
      tmode=VMLSETMODE(tmode)
      call VCPOWX(vec_len,cA,cA(6),cBla2)

      mode=VML_HA
      call VMCPOWX(vec_len,cA,cA(6),cBha1,mode)

      tmode=VML_HA
      tmode=VMLSETMODE(tmode)
      call VCPOWX(vec_len,cA,cA(6),cBha2)

      do i=1,10
          if(cBha0(i) .ne. cBha1(i)) then
              print *,"Error! Difference between VCPOWX and"
              print *," VMCPOWX in VML_HA mode detected"
              stop 1
          endif
          if(cBha1(i) .ne. cBha2(i)) then
              print *,"Error! Difference between VCPOWX and"
              print *," VMCPOWX in VML_HA mode detected"
              stop 1
          endif
          if(cBla1(i) .ne. cBla2(i)) then
              print *,"Error! Difference between VCPOWX and"
              print *," VMCPOWX in VML_LA mode detected"
              stop 1
          endif
          if(cBep1(i) .ne. cBep2(i)) then
              print *,"Error! Difference between VCPOWX and"
              print *," VMCPOWX in VML_EP mode detected"
              stop 1
          endif
      end do

      print *,"vcPowx test/example program"
      print *,""
      print *,"           Argument                     vcPowx"
      print *,"======================================================", &
     &        "========================"
      do i=1,vec_len
            print 10,cA(i),"    ",cBha0(i)
            CurRMS=crelerr(cB(i),cBha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E15.7,E15.7,A5,E15.7,E15.7)
11    format(A,F25.16)

      end
