!===============================================================================
! Copyright 2001-2016 Intel Corporation All Rights Reserved.
!
! The source code,  information  and material  ("Material") contained  herein is
! owned by Intel Corporation or its  suppliers or licensors,  and  title to such
! Material remains with Intel  Corporation or its  suppliers or  licensors.  The
! Material  contains  proprietary  information  of  Intel or  its suppliers  and
! licensors.  The Material is protected by  worldwide copyright  laws and treaty
! provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
! modified, published,  uploaded, posted, transmitted,  distributed or disclosed
! in any way without Intel's prior express written permission.  No license under
! any patent,  copyright or other  intellectual property rights  in the Material
! is granted to  or  conferred  upon  you,  either   expressly,  by implication,
! inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
! property rights must be express and approved by Intel in writing.
!
! Unless otherwise agreed by Intel in writing,  you may not remove or alter this
! notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
! suppliers or licensors in any way.
!===============================================================================

!  Content:
!    vdErfInv  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.f90"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=8) dA(10)
      real(kind=8) dB(10)
      real(kind=8) dBha0(10)
      real(kind=8) dBha1(10)
      real(kind=8) dBha2(10)
      real(kind=8) dBla1(10)
      real(kind=8) dBla2(10)
      real(kind=8) dBep1(10)
      real(kind=8) dBep2(10)

      real(kind=8) CurRMS,MaxRMS

      integer(kind=8) mode
      integer tmode
      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      dA( 1)=0.0100d+000
      dA( 2)=0.1188d+000
      dA( 3)=0.2277d+000
      dA( 4)=0.3366d+000
      dA( 5)=0.4455d+000
      dA( 6)=0.5544d+000
      dA( 7)=0.6633d+000
      dA( 8)=0.7722d+000
      dA( 9)=0.8811d+000
      dA(10)=0.9900d+000
      dB( 1)=8.8625012809505979d-003
      dB( 2)=1.0567581831000064d-001
      dB( 3)=2.0461387202766912d-001
      dB( 4)=3.0774968941144704d-001
      dB( 5)=4.1792165882573973d-001
      dB( 6)=5.3936052169714166d-001
      dB( 7)=6.7932174635974640d-001
      dB( 8)=8.5280285439695180d-001
      dB( 9)=1.1026675051940427d+000
      dB(10)=1.8213863677184494d+000

      call VDERFINV(vec_len,dA,dBha0)

      mode=VML_EP
      call VMDERFINV(vec_len,dA,dBep1,mode)

      tmode=VML_EP
      tmode=VMLSETMODE(tmode)
      call VDERFINV(vec_len,dA,dBep2)

      mode=VML_LA
      call VMDERFINV(vec_len,dA,dBla1,mode)

      tmode=VML_LA
      tmode=VMLSETMODE(tmode)
      call VDERFINV(vec_len,dA,dBla2)

      mode=VML_HA
      call VMDERFINV(vec_len,dA,dBha1,mode)

      tmode=VML_HA
      tmode=VMLSETMODE(tmode)
      call VDERFINV(vec_len,dA,dBha2)

      do i=1,10
          if(dBha0(i) .ne. dBha1(i)) then
              print *,"Error! Difference between VDERFINV and"
              print *," VMDERFINV in VML_HA mode detected"
              stop 1
          endif
          if(dBha1(i) .ne. dBha2(i)) then
              print *,"Error! Difference between VDERFINV and"
              print *," VMDERFINV in VML_HA mode detected"
              stop 1
          endif
          if(dBla1(i) .ne. dBla2(i)) then
              print *,"Error! Difference between VDERFINV and"
              print *," VMDERFINV in VML_LA mode detected"
              stop 1
          endif
          if(dBep1(i) .ne. dBep2(i)) then
              print *,"Error! Difference between VDERFINV and"
              print *," VMDERFINV in VML_EP mode detected"
              stop 1
          endif
      end do

      print *,"vdErfInv test/example program"
      print *,""
      print *,"           Argument                     vdErfInv"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,dA(i),dBha0(i)
            CurRMS=drelerr(dB(i),dBha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-14) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14)
11    format(A,F25.16)

      end
