!===============================================================================
! Copyright 2001-2016 Intel Corporation All Rights Reserved.
!
! The source code,  information  and material  ("Material") contained  herein is
! owned by Intel Corporation or its  suppliers or licensors,  and  title to such
! Material remains with Intel  Corporation or its  suppliers or  licensors.  The
! Material  contains  proprietary  information  of  Intel or  its suppliers  and
! licensors.  The Material is protected by  worldwide copyright  laws and treaty
! provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
! modified, published,  uploaded, posted, transmitted,  distributed or disclosed
! in any way without Intel's prior express written permission.  No license under
! any patent,  copyright or other  intellectual property rights  in the Material
! is granted to  or  conferred  upon  you,  either   expressly,  by implication,
! inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
! property rights must be express and approved by Intel in writing.
!
! Unless otherwise agreed by Intel in writing,  you may not remove or alter this
! notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
! suppliers or licensors in any way.
!===============================================================================

!  Content:
!    vdLog1p  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.f90"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=8) dA(10)
      real(kind=8) dB(10)
      real(kind=8) dBha0(10)
      real(kind=8) dBha1(10)
      real(kind=8) dBha2(10)
      real(kind=8) dBla1(10)
      real(kind=8) dBla2(10)
      real(kind=8) dBep1(10)
      real(kind=8) dBep2(10)

      real(kind=8) CurRMS,MaxRMS

      integer(kind=8) mode
      integer tmode
      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      dA( 1)=0.1000d+000
      dA( 2)=1111.1999d+000
      dA( 3)=2222.2999d+000
      dA( 4)=3333.3999d+000
      dA( 5)=4444.5000d+000
      dA( 6)=5555.6000d+000
      dA( 7)=6666.7000d+000
      dA( 8)=7777.8000d+000
      dA( 9)=8888.9000d+000
      dA(10)=10000.0000d+000
      dB( 1)=9.5310179804324865d-002
      dB( 2)=7.0140952248415731d+000
      dB( 3)=7.7067478126472366d+000
      dB( 4)=8.1120480021285903d+000
      dB( 5)=8.3996476275611940d+000
      dB( 6)=8.6227416894042790d+000
      dB( 7)=8.8050302518567598d+000
      dB( 8)=8.9591573636307267d+000
      dB( 9)=9.0926710798507582d+000
      dB(10)=9.2104403669765169d+000

      call VDLOG1P(vec_len,dA,dBha0)

      mode=VML_EP
      call VMDLOG1P(vec_len,dA,dBep1,mode)

      tmode=VML_EP
      tmode=VMLSETMODE(tmode)
      call VDLOG1P(vec_len,dA,dBep2)

      mode=VML_LA
      call VMDLOG1P(vec_len,dA,dBla1,mode)

      tmode=VML_LA
      tmode=VMLSETMODE(tmode)
      call VDLOG1P(vec_len,dA,dBla2)

      mode=VML_HA
      call VMDLOG1P(vec_len,dA,dBha1,mode)

      tmode=VML_HA
      tmode=VMLSETMODE(tmode)
      call VDLOG1P(vec_len,dA,dBha2)

      do i=1,10
          if(dBha0(i) .ne. dBha1(i)) then
              print *,"Error! Difference between VDLOG1P and"
              print *," VMDLOG1P in VML_HA mode detected"
              stop 1
          endif
          if(dBha1(i) .ne. dBha2(i)) then
              print *,"Error! Difference between VDLOG1P and"
              print *," VMDLOG1P in VML_HA mode detected"
              stop 1
          endif
          if(dBla1(i) .ne. dBla2(i)) then
              print *,"Error! Difference between VDLOG1P and"
              print *," VMDLOG1P in VML_LA mode detected"
              stop 1
          endif
          if(dBep1(i) .ne. dBep2(i)) then
              print *,"Error! Difference between VDLOG1P and"
              print *," VMDLOG1P in VML_EP mode detected"
              stop 1
          endif
      end do

      print *,"vdLog1p test/example program"
      print *,""
      print *,"           Argument                     vdLog1p"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,dA(i),dBha0(i)
            CurRMS=drelerr(dB(i),dBha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-14) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14)
11    format(A,F25.16)

      end
