!===============================================================================
! Copyright 2001-2016 Intel Corporation All Rights Reserved.
!
! The source code,  information  and material  ("Material") contained  herein is
! owned by Intel Corporation or its  suppliers or licensors,  and  title to such
! Material remains with Intel  Corporation or its  suppliers or  licensors.  The
! Material  contains  proprietary  information  of  Intel or  its suppliers  and
! licensors.  The Material is protected by  worldwide copyright  laws and treaty
! provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
! modified, published,  uploaded, posted, transmitted,  distributed or disclosed
! in any way without Intel's prior express written permission.  No license under
! any patent,  copyright or other  intellectual property rights  in the Material
! is granted to  or  conferred  upon  you,  either   expressly,  by implication,
! inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
! property rights must be express and approved by Intel in writing.
!
! Unless otherwise agreed by Intel in writing,  you may not remove or alter this
! notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
! suppliers or licensors in any way.
!===============================================================================

!  Content:
!    vdPow2o3  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.f90"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=8) dA(10)
      real(kind=8) dB(10)
      real(kind=8) dBha0(10)
      real(kind=8) dBha1(10)
      real(kind=8) dBha2(10)
      real(kind=8) dBla1(10)
      real(kind=8) dBla2(10)
      real(kind=8) dBep1(10)
      real(kind=8) dBep2(10)

      real(kind=8) CurRMS,MaxRMS

      integer(kind=8) mode
      integer tmode
      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      dA( 1)=1.0000d+000
      dA( 2)=1.6666d+000
      dA( 3)=2.3333d+000
      dA( 4)=3.0000d+000
      dA( 5)=3.6666d+000
      dA( 6)=4.3333d+000
      dA( 7)=5.0000d+000
      dA( 8)=5.6666d+000
      dA( 9)=6.3333d+000
      dA(10)=7.0000d+000
      dB( 1)=1.0000000000000000d+000
      dB( 2)=1.4056836226901026d+000
      dB( 3)=1.7591939415405531d+000
      dB( 4)=2.0800838230519041d+000
      dB( 5)=2.3778020076302173d+000
      dB( 6)=2.6579440692151435d+000
      dB( 7)=2.9240177382128660d+000
      dB( 8)=3.1784474694102087d+000
      dB( 9)=3.4231035769933422d+000
      dB(10)=3.6593057100229713d+000

      call VDPOW2O3(vec_len,dA,dBha0)

      mode=VML_EP
      call VMDPOW2O3(vec_len,dA,dBep1,mode)

      tmode=VML_EP
      tmode=VMLSETMODE(tmode)
      call VDPOW2O3(vec_len,dA,dBep2)

      mode=VML_LA
      call VMDPOW2O3(vec_len,dA,dBla1,mode)

      tmode=VML_LA
      tmode=VMLSETMODE(tmode)
      call VDPOW2O3(vec_len,dA,dBla2)

      mode=VML_HA
      call VMDPOW2O3(vec_len,dA,dBha1,mode)

      tmode=VML_HA
      tmode=VMLSETMODE(tmode)
      call VDPOW2O3(vec_len,dA,dBha2)

      do i=1,10
          if(dBha0(i) .ne. dBha1(i)) then
              print *,"Error! Difference between VDPOW2O3 and"
              print *," VMDPOW2O3 in VML_HA mode detected"
              stop 1
          endif
          if(dBha1(i) .ne. dBha2(i)) then
              print *,"Error! Difference between VDPOW2O3 and"
              print *," VMDPOW2O3 in VML_HA mode detected"
              stop 1
          endif
          if(dBla1(i) .ne. dBla2(i)) then
              print *,"Error! Difference between VDPOW2O3 and"
              print *," VMDPOW2O3 in VML_LA mode detected"
              stop 1
          endif
          if(dBep1(i) .ne. dBep2(i)) then
              print *,"Error! Difference between VDPOW2O3 and"
              print *," VMDPOW2O3 in VML_EP mode detected"
              stop 1
          endif
      end do

      print *,"vdPow2o3 test/example program"
      print *,""
      print *,"           Argument                     vdPow2o3"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,dA(i),dBha0(i)
            CurRMS=drelerr(dB(i),dBha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-14) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14)
11    format(A,F25.16)

      end
