!===============================================================================
! Copyright 2001-2016 Intel Corporation All Rights Reserved.
!
! The source code,  information  and material  ("Material") contained  herein is
! owned by Intel Corporation or its  suppliers or licensors,  and  title to such
! Material remains with Intel  Corporation or its  suppliers or  licensors.  The
! Material  contains  proprietary  information  of  Intel or  its suppliers  and
! licensors.  The Material is protected by  worldwide copyright  laws and treaty
! provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
! modified, published,  uploaded, posted, transmitted,  distributed or disclosed
! in any way without Intel's prior express written permission.  No license under
! any patent,  copyright or other  intellectual property rights  in the Material
! is granted to  or  conferred  upon  you,  either   expressly,  by implication,
! inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
! property rights must be express and approved by Intel in writing.
!
! Unless otherwise agreed by Intel in writing,  you may not remove or alter this
! notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
! suppliers or licensors in any way.
!===============================================================================

!  Content:
!    vsCdfNorm  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.f90"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=4) fA(10)
      real(kind=4) fB(10)
      real(kind=4) fBha0(10)
      real(kind=4) fBha1(10)
      real(kind=4) fBha2(10)
      real(kind=4) fBla1(10)
      real(kind=4) fBla2(10)
      real(kind=4) fBep1(10)
      real(kind=4) fBep2(10)

      real(kind=4) CurRMS,MaxRMS

      integer(kind=8) mode
      integer tmode
      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      fA( 1)=-8.0000
      fA( 2)=-6.5555
      fA( 3)=-5.1111
      fA( 4)=-3.6666
      fA( 5)=-2.2222
      fA( 6)=-0.7777
      fA( 7)=0.6666
      fA( 8)=2.1111
      fA( 9)=3.5555
      fA(10)=5.0000
      fB( 1)=6.22096057427178e-16
      fB( 2)=2.77278689399088e-11
      fB( 3)=1.60144022698396e-07
      fB( 4)=1.22898417236556e-04
      fB( 5)=1.31348990439007e-02
      fB( 6)=2.18372944048033e-01
      fB( 7)=7.47486161912039e-01
      fB( 8)=9.82618139490682e-01
      fB( 9)=9.99811369549446e-01
      fB(10)=9.99999713348428e-01

      call VSCDFNORM(vec_len,fA,fBha0)

      mode=VML_EP
      call VMSCDFNORM(vec_len,fA,fBep1,mode)

      tmode=VML_EP
      tmode=VMLSETMODE(tmode)
      call VSCDFNORM(vec_len,fA,fBep2)

      mode=VML_LA
      call VMSCDFNORM(vec_len,fA,fBla1,mode)

      tmode=VML_LA
      tmode=VMLSETMODE(tmode)
      call VSCDFNORM(vec_len,fA,fBla2)

      mode=VML_HA
      call VMSCDFNORM(vec_len,fA,fBha1,mode)

      tmode=VML_HA
      tmode=VMLSETMODE(tmode)
      call VSCDFNORM(vec_len,fA,fBha2)

      do i=1,10
          if(fBha0(i) .ne. fBha1(i)) then
              print *,"Error! Difference between VSCDFNORM and"
              print *," VMSCDFNORM in VML_HA mode detected"
              stop 1
          endif
          if(fBha1(i) .ne. fBha2(i)) then
              print *,"Error! Difference between VSCDFNORM and"
              print *," VMSCDFNORM in VML_HA mode detected"
              stop 1
          endif
          if(fBla1(i) .ne. fBla2(i)) then
              print *,"Error! Difference between VSCDFNORM and"
              print *," VMSCDFNORM in VML_LA mode detected"
              stop 1
          endif
          if(fBep1(i) .ne. fBep2(i)) then
              print *,"Error! Difference between VSCDFNORM and"
              print *," VMSCDFNORM in VML_EP mode detected"
              stop 1
          endif
      end do

      print *,"vsCdfNorm test/example program"
      print *,""
      print *,"           Argument                     vsCdfNorm"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,fA(i),fBha0(i)
            CurRMS=srelerr(fB(i),fBha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14)
11    format(A,F25.16)

      end
