!===============================================================================
! Copyright 2001-2016 Intel Corporation All Rights Reserved.
!
! The source code,  information  and material  ("Material") contained  herein is
! owned by Intel Corporation or its  suppliers or licensors,  and  title to such
! Material remains with Intel  Corporation or its  suppliers or  licensors.  The
! Material  contains  proprietary  information  of  Intel or  its suppliers  and
! licensors.  The Material is protected by  worldwide copyright  laws and treaty
! provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
! modified, published,  uploaded, posted, transmitted,  distributed or disclosed
! in any way without Intel's prior express written permission.  No license under
! any patent,  copyright or other  intellectual property rights  in the Material
! is granted to  or  conferred  upon  you,  either   expressly,  by implication,
! inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
! property rights must be express and approved by Intel in writing.
!
! Unless otherwise agreed by Intel in writing,  you may not remove or alter this
! notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
! suppliers or licensors in any way.
!===============================================================================

!  Content:
!    vsInvSqrt  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.f90"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=4) fA(10)
      real(kind=4) fB(10)
      real(kind=4) fBha0(10)
      real(kind=4) fBha1(10)
      real(kind=4) fBha2(10)
      real(kind=4) fBla1(10)
      real(kind=4) fBla2(10)
      real(kind=4) fBep1(10)
      real(kind=4) fBep2(10)

      real(kind=4) CurRMS,MaxRMS

      integer(kind=8) mode
      integer tmode
      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      fA( 1)=0.1000
      fA( 2)=1111.2000
      fA( 3)=2222.2998
      fA( 4)=3333.3999
      fA( 5)=4444.5000
      fA( 6)=5555.6001
      fA( 7)=6666.7002
      fA( 8)=7777.7998
      fA( 9)=8888.9004
      fA(10)=10000.0000
      fB( 1)=3.1622776366075751e+000
      fB( 2)=2.9998800731095811e-002
      fB( 3)=2.1212833146452812e-002
      fB( 4)=1.7320335126916823e-002
      fB( 5)=1.4999906250878898e-002
      fB( 6)=1.3416354081773038e-002
      fB( 7)=1.2247417916004286e-002
      fB( 8)=1.1338918134202937e-002
      fB( 9)=1.0606594855623586e-002
      fB(10)=1.0000000000000000e-002

      call VSINVSQRT(vec_len,fA,fBha0)

      mode=VML_EP
      call VMSINVSQRT(vec_len,fA,fBep1,mode)

      tmode=VML_EP
      tmode=VMLSETMODE(tmode)
      call VSINVSQRT(vec_len,fA,fBep2)

      mode=VML_LA
      call VMSINVSQRT(vec_len,fA,fBla1,mode)

      tmode=VML_LA
      tmode=VMLSETMODE(tmode)
      call VSINVSQRT(vec_len,fA,fBla2)

      mode=VML_HA
      call VMSINVSQRT(vec_len,fA,fBha1,mode)

      tmode=VML_HA
      tmode=VMLSETMODE(tmode)
      call VSINVSQRT(vec_len,fA,fBha2)

      do i=1,10
          if(fBha0(i) .ne. fBha1(i)) then
              print *,"Error! Difference between VSINVSQRT and"
              print *," VMSINVSQRT in VML_HA mode detected"
              stop 1
          endif
          if(fBha1(i) .ne. fBha2(i)) then
              print *,"Error! Difference between VSINVSQRT and"
              print *," VMSINVSQRT in VML_HA mode detected"
              stop 1
          endif
          if(fBla1(i) .ne. fBla2(i)) then
              print *,"Error! Difference between VSINVSQRT and"
              print *," VMSINVSQRT in VML_LA mode detected"
              stop 1
          endif
          if(fBep1(i) .ne. fBep2(i)) then
              print *,"Error! Difference between VSINVSQRT and"
              print *," VMSINVSQRT in VML_EP mode detected"
              stop 1
          endif
      end do

      print *,"vsInvSqrt test/example program"
      print *,""
      print *,"           Argument                     vsInvSqrt"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,fA(i),fBha0(i)
            CurRMS=srelerr(fB(i),fBha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14)
11    format(A,F25.16)

      end
