!===============================================================================
! Copyright 2001-2016 Intel Corporation All Rights Reserved.
!
! The source code,  information  and material  ("Material") contained  herein is
! owned by Intel Corporation or its  suppliers or licensors,  and  title to such
! Material remains with Intel  Corporation or its  suppliers or  licensors.  The
! Material  contains  proprietary  information  of  Intel or  its suppliers  and
! licensors.  The Material is protected by  worldwide copyright  laws and treaty
! provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
! modified, published,  uploaded, posted, transmitted,  distributed or disclosed
! in any way without Intel's prior express written permission.  No license under
! any patent,  copyright or other  intellectual property rights  in the Material
! is granted to  or  conferred  upon  you,  either   expressly,  by implication,
! inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
! property rights must be express and approved by Intel in writing.
!
! Unless otherwise agreed by Intel in writing,  you may not remove or alter this
! notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
! suppliers or licensors in any way.
!===============================================================================

!  Content:
!    vsPow3o2  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.f90"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=4) fA(10)
      real(kind=4) fB(10)
      real(kind=4) fBha0(10)
      real(kind=4) fBha1(10)
      real(kind=4) fBha2(10)
      real(kind=4) fBla1(10)
      real(kind=4) fBla2(10)
      real(kind=4) fBep1(10)
      real(kind=4) fBep2(10)

      real(kind=4) CurRMS,MaxRMS

      integer(kind=8) mode
      integer tmode
      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      fA( 1)=1.0000
      fA( 2)=1.6666
      fA( 3)=2.3333
      fA( 4)=3.0000
      fA( 5)=3.6666
      fA( 6)=4.3333
      fA( 7)=5.0000
      fA( 8)=5.6666
      fA( 9)=6.3333
      fA(10)=7.0000
      fB( 1)=1.0000000000000000e+000
      fB( 2)=2.1515282949835584e+000
      fB( 3)=3.5641494249995125e+000
      fB( 4)=5.1961524227066320e+000
      fB( 5)=7.0209406072206448e+000
      fB( 6)=9.0204489362114408e+000
      fB( 7)=1.1180339887498949e+001
      fB( 8)=1.3489127574374065e+001
      fB( 9)=1.5938413962064837e+001
      fB(10)=1.8520259177452136e+001

      call VSPOW3O2(vec_len,fA,fBha0)

      mode=VML_EP
      call VMSPOW3O2(vec_len,fA,fBep1,mode)

      tmode=VML_EP
      tmode=VMLSETMODE(tmode)
      call VSPOW3O2(vec_len,fA,fBep2)

      mode=VML_LA
      call VMSPOW3O2(vec_len,fA,fBla1,mode)

      tmode=VML_LA
      tmode=VMLSETMODE(tmode)
      call VSPOW3O2(vec_len,fA,fBla2)

      mode=VML_HA
      call VMSPOW3O2(vec_len,fA,fBha1,mode)

      tmode=VML_HA
      tmode=VMLSETMODE(tmode)
      call VSPOW3O2(vec_len,fA,fBha2)

      do i=1,10
          if(fBha0(i) .ne. fBha1(i)) then
              print *,"Error! Difference between VSPOW3O2 and"
              print *," VMSPOW3O2 in VML_HA mode detected"
              stop 1
          endif
          if(fBha1(i) .ne. fBha2(i)) then
              print *,"Error! Difference between VSPOW3O2 and"
              print *," VMSPOW3O2 in VML_HA mode detected"
              stop 1
          endif
          if(fBla1(i) .ne. fBla2(i)) then
              print *,"Error! Difference between VSPOW3O2 and"
              print *," VMSPOW3O2 in VML_LA mode detected"
              stop 1
          endif
          if(fBep1(i) .ne. fBep2(i)) then
              print *,"Error! Difference between VSPOW3O2 and"
              print *," VMSPOW3O2 in VML_EP mode detected"
              stop 1
          endif
      end do

      print *,"vsPow3o2 test/example program"
      print *,""
      print *,"           Argument                     vsPow3o2"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,fA(i),fBha0(i)
            CurRMS=srelerr(fB(i),fBha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14)
11    format(A,F25.16)

      end
