!===============================================================================
! Copyright 2001-2016 Intel Corporation All Rights Reserved.
!
! The source code,  information  and material  ("Material") contained  herein is
! owned by Intel Corporation or its  suppliers or licensors,  and  title to such
! Material remains with Intel  Corporation or its  suppliers or  licensors.  The
! Material  contains  proprietary  information  of  Intel or  its suppliers  and
! licensors.  The Material is protected by  worldwide copyright  laws and treaty
! provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
! modified, published,  uploaded, posted, transmitted,  distributed or disclosed
! in any way without Intel's prior express written permission.  No license under
! any patent,  copyright or other  intellectual property rights  in the Material
! is granted to  or  conferred  upon  you,  either   expressly,  by implication,
! inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
! property rights must be express and approved by Intel in writing.
!
! Unless otherwise agreed by Intel in writing,  you may not remove or alter this
! notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
! suppliers or licensors in any way.
!===============================================================================

!  Content:
!    vsPowx  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.f90"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=4) fA(10)
      real(kind=4) fB(10)
      real(kind=4) fBha0(10)
      real(kind=4) fBha1(10)
      real(kind=4) fBha2(10)
      real(kind=4) fBla1(10)
      real(kind=4) fBla2(10)
      real(kind=4) fBep1(10)
      real(kind=4) fBep2(10)

      real(kind=4) CurRMS,MaxRMS

      integer(kind=8) mode
      integer tmode
      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      fA( 1)=0.1000
      fA( 2)=0.8666
      fA( 3)=1.6333
      fA( 4)=2.4000
      fA( 5)=3.1666
      fA( 6)=3.9333
      fA( 7)=4.7000
      fA( 8)=5.4666
      fA( 9)=6.2333
      fA(10)=7.0000
      fB( 1)=1.1660039110312152e-004
      fB( 2)=5.6940619267520864e-001
      fB( 3)=6.8873522741537876e+000
      fB( 4)=3.1295720312255717e+001
      fB( 5)=9.3107199918766597e+001
      fB( 6)=2.1845299866537277e+002
      fB( 7)=4.4011122728416541e+002
      fB( 8)=7.9737651355941364e+002
      fB( 9)=1.3361785535769964e+003
      fB(10)=2.1087453418813361e+003

      call VSPOWX(vec_len,fA,fA(6),fBha0)

      mode=VML_EP
      call VMSPOWX(vec_len,fA,fA(6),fBep1,mode)

      tmode=VML_EP
      tmode=VMLSETMODE(tmode)
      call VSPOWX(vec_len,fA,fA(6),fBep2)

      mode=VML_LA
      call VMSPOWX(vec_len,fA,fA(6),fBla1,mode)

      tmode=VML_LA
      tmode=VMLSETMODE(tmode)
      call VSPOWX(vec_len,fA,fA(6),fBla2)

      mode=VML_HA
      call VMSPOWX(vec_len,fA,fA(6),fBha1,mode)

      tmode=VML_HA
      tmode=VMLSETMODE(tmode)
      call VSPOWX(vec_len,fA,fA(6),fBha2)

      do i=1,10
          if(fBha0(i) .ne. fBha1(i)) then
              print *,"Error! Difference between VSPOWX and"
              print *," VMSPOWX in VML_HA mode detected"
              stop 1
          endif
          if(fBha1(i) .ne. fBha2(i)) then
              print *,"Error! Difference between VSPOWX and"
              print *," VMSPOWX in VML_HA mode detected"
              stop 1
          endif
          if(fBla1(i) .ne. fBla2(i)) then
              print *,"Error! Difference between VSPOWX and"
              print *," VMSPOWX in VML_LA mode detected"
              stop 1
          endif
          if(fBep1(i) .ne. fBep2(i)) then
              print *,"Error! Difference between VSPOWX and"
              print *," VMSPOWX in VML_EP mode detected"
              stop 1
          endif
      end do

      print *,"vsPowx test/example program"
      print *,""
      print *,"           Argument                     vsPowx"
      print *,"======================================================", &
     &        "========================"
      do i=1,10
            print 10,fA(i),fBha0(i)
            CurRMS=srelerr(fB(i),fBha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-5) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E25.14,E25.14)
11    format(A,F25.16)

      end
