!===============================================================================
! Copyright 2001-2016 Intel Corporation All Rights Reserved.
!
! The source code,  information  and material  ("Material") contained  herein is
! owned by Intel Corporation or its  suppliers or licensors,  and  title to such
! Material remains with Intel  Corporation or its  suppliers or  licensors.  The
! Material  contains  proprietary  information  of  Intel or  its suppliers  and
! licensors.  The Material is protected by  worldwide copyright  laws and treaty
! provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
! modified, published,  uploaded, posted, transmitted,  distributed or disclosed
! in any way without Intel's prior express written permission.  No license under
! any patent,  copyright or other  intellectual property rights  in the Material
! is granted to  or  conferred  upon  you,  either   expressly,  by implication,
! inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
! property rights must be express and approved by Intel in writing.
!
! Unless otherwise agreed by Intel in writing,  you may not remove or alter this
! notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
! suppliers or licensors in any way.
!===============================================================================

!  Content:
!    vzAcos  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.f90"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      complex(kind=8) zA(10)
      complex(kind=8) zB(10)
      complex(kind=8) zBha0(10)
      complex(kind=8) zBha1(10)
      complex(kind=8) zBha2(10)
      complex(kind=8) zBla1(10)
      complex(kind=8) zBla2(10)
      complex(kind=8) zBep1(10)
      complex(kind=8) zBep2(10)

      real(kind=8) CurRMS,MaxRMS

      integer(kind=8) mode
      integer tmode
      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      zA( 1)=(-0.9000d+000,0.9000d+000)
      zA( 2)=(-0.7000d+000,0.7000d+000)
      zA( 3)=(-0.5000d+000,0.5000d+000)
      zA( 4)=(-0.2999d+000,0.2999d+000)
      zA( 5)=(-0.0999d+000,0.0999d+000)
      zA( 6)=(0.0999d+000,-0.0999d+000)
      zA( 7)=(0.3000d+000,-0.3000d+000)
      zA( 8)=(0.5000d+000,-0.5000d+000)
      zA( 9)=(0.7000d+000,-0.7000d+000)
      zA(10)=(0.9000d+000,-0.9000d+000)
      zB( 1)=(2.2123245753427025d+000,-9.6595636090332149d-001)
      zB( 2)=(2.1393931242264199d+000,-7.5646598100109175d-001)
      zB( 3)=(2.0230747739460875d+000,-5.3063753095251787d-001)
      zB( 4)=(1.8610635913216587d+000,-3.0809589760000972d-001)
      zB( 5)=(1.6703610433715261d+000,-1.0022931432671847d-001)
      zB( 6)=(1.4712316102182672d+000,1.0022931432671847d-001)
      zB( 7)=(1.2804390679875004d+000,3.0820353078157842d-001)
      zB( 8)=(1.1185178796437059d+000,5.3063753095251787d-001)
      zB( 9)=(1.0021995293633732d+000,7.5646598100109175d-001)
      zB(10)=(9.2926807824709057d-001,9.6595636090332149d-001)

      call VZACOS(vec_len,zA,zBha0)

      mode=VML_EP
      call VMZACOS(vec_len,zA,zBep1,mode)

      tmode=VML_EP
      tmode=VMLSETMODE(tmode)
      call VZACOS(vec_len,zA,zBep2)

      mode=VML_LA
      call VMZACOS(vec_len,zA,zBla1,mode)

      tmode=VML_LA
      tmode=VMLSETMODE(tmode)
      call VZACOS(vec_len,zA,zBla2)

      mode=VML_HA
      call VMZACOS(vec_len,zA,zBha1,mode)

      tmode=VML_HA
      tmode=VMLSETMODE(tmode)
      call VZACOS(vec_len,zA,zBha2)

      do i=1,10
          if(zBha0(i) .ne. zBha1(i)) then
              print *,"Error! Difference between VZACOS and"
              print *," VMZACOS in VML_HA mode detected"
              stop 1
          endif
          if(zBha1(i) .ne. zBha2(i)) then
              print *,"Error! Difference between VZACOS and"
              print *," VMZACOS in VML_HA mode detected"
              stop 1
          endif
          if(zBla1(i) .ne. zBla2(i)) then
              print *,"Error! Difference between VZACOS and"
              print *," VMZACOS in VML_LA mode detected"
              stop 1
          endif
          if(zBep1(i) .ne. zBep2(i)) then
              print *,"Error! Difference between VZACOS and"
              print *," VMZACOS in VML_EP mode detected"
              stop 1
          endif
      end do

      print *,"vzAcos test/example program"
      print *,""
      print *,"           Argument                     vzAcos"
      print *,"======================================================", &
     &        "========================"
      do i=1,vec_len
            print 10,zA(i),"    ",zBha0(i)
            CurRMS=zrelerr(zB(i),zBha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-14) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E15.7,E15.7,A5,E15.7,E15.7)
11    format(A,F25.16)

      end
