!===============================================================================
! Copyright 2001-2016 Intel Corporation All Rights Reserved.
!
! The source code,  information  and material  ("Material") contained  herein is
! owned by Intel Corporation or its  suppliers or licensors,  and  title to such
! Material remains with Intel  Corporation or its  suppliers or  licensors.  The
! Material  contains  proprietary  information  of  Intel or  its suppliers  and
! licensors.  The Material is protected by  worldwide copyright  laws and treaty
! provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
! modified, published,  uploaded, posted, transmitted,  distributed or disclosed
! in any way without Intel's prior express written permission.  No license under
! any patent,  copyright or other  intellectual property rights  in the Material
! is granted to  or  conferred  upon  you,  either   expressly,  by implication,
! inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
! property rights must be express and approved by Intel in writing.
!
! Unless otherwise agreed by Intel in writing,  you may not remove or alter this
! notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
! suppliers or licensors in any way.
!===============================================================================

!  Content:
!    vzCIS  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.f90"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      real(kind=8) dA(10)
      complex(kind=8) zB(10)
      complex(kind=8) zBha0(10)
      complex(kind=8) zBha1(10)
      complex(kind=8) zBha2(10)
      complex(kind=8) zBla1(10)
      complex(kind=8) zBla2(10)
      complex(kind=8) zBep1(10)
      complex(kind=8) zBep2(10)

      real(kind=8) CurRMS,MaxRMS

      integer(kind=8) mode
      integer tmode
      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      dA( 1)=-10000.0000d+000
      dA( 2)=-7777.7777d+000
      dA( 3)=-5555.5555d+000
      dA( 4)=-3333.3333d+000
      dA( 5)=-1111.1111d+000
      dA( 6)=1111.1111d+000
      dA( 7)=3333.3333d+000
      dA( 8)=5555.5555d+000
      dA( 9)=7777.7777d+000
      dA(10)=10000.0000d+000
      zB( 1)=(-9.5215536825901481d-001,3.0561438888825215d-001)
      zB( 2)=(6.9259906263181004d-001,7.2132276994528466d-001)
      zB( 3)=(3.4393830299014322d-001,-9.3899224902885137d-001)
      zB( 4)=(-9.9464921859866051d-001,1.0330988307550266d-001)
      zB( 5)=(5.2957287328011915d-001,8.4826444690664649d-001)
      zB( 6)=(5.2957287328011915d-001,-8.4826444690664649d-001)
      zB( 7)=(-9.9464921859866051d-001,-1.0330988307550266d-001)
      zB( 8)=(3.4393830299014322d-001,9.3899224902885137d-001)
      zB( 9)=(6.9259906263181004d-001,-7.2132276994528466d-001)
      zB(10)=(-9.5215536825901481d-001,-3.0561438888825215d-001)

      call VZCIS(vec_len,dA,zBha0)

      mode=VML_EP
      call VMZCIS(vec_len,dA,zBep1,mode)

      tmode=VML_EP
      tmode=VMLSETMODE(tmode)
      call VZCIS(vec_len,dA,zBep2)

      mode=VML_LA
      call VMZCIS(vec_len,dA,zBla1,mode)

      tmode=VML_LA
      tmode=VMLSETMODE(tmode)
      call VZCIS(vec_len,dA,zBla2)

      mode=VML_HA
      call VMZCIS(vec_len,dA,zBha1,mode)

      tmode=VML_HA
      tmode=VMLSETMODE(tmode)
      call VZCIS(vec_len,dA,zBha2)

      do i=1,10
          if(zBha0(i) .ne. zBha1(i)) then
              print *,"Error! Difference between VZCIS and"
              print *," VMCCIS in VML_HA mode detected"
              stop 1
          endif
          if(zBha1(i) .ne. zBha2(i)) then
              print *,"Error! Difference between VZCIS and"
              print *," VMCCIS in VML_HA mode detected"
              stop 1
          endif
          if(zBla1(i) .ne. zBla2(i)) then
              print *,"Error! Difference between VZCIS and"
              print *," VMCCIS in VML_LA mode detected"
              stop 1
          endif
          if(zBep1(i) .ne. zBep2(i)) then
              print *,"Error! Difference between VZCIS and"
              print *," VMCCIS in VML_EP mode detected"
              stop 1
          endif
      end do

      print *,"vzCIS test/example program"
      print *,""
      print *,"   Argument                     vzCIS"
      print *,"======================================================", &
     &        "========================"
      do i=1,vec_len
            print 10,dA(i),"    ",zBha0(i)
            CurRMS=zrelerr(zB(i),zBha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-14) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E15.7,A5,E20.10,E20.10)
11    format(A,F25.16)

      end
