!===============================================================================
! Copyright 2001-2016 Intel Corporation All Rights Reserved.
!
! The source code,  information  and material  ("Material") contained  herein is
! owned by Intel Corporation or its  suppliers or licensors,  and  title to such
! Material remains with Intel  Corporation or its  suppliers or  licensors.  The
! Material  contains  proprietary  information  of  Intel or  its suppliers  and
! licensors.  The Material is protected by  worldwide copyright  laws and treaty
! provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
! modified, published,  uploaded, posted, transmitted,  distributed or disclosed
! in any way without Intel's prior express written permission.  No license under
! any patent,  copyright or other  intellectual property rights  in the Material
! is granted to  or  conferred  upon  you,  either   expressly,  by implication,
! inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
! property rights must be express and approved by Intel in writing.
!
! Unless otherwise agreed by Intel in writing,  you may not remove or alter this
! notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
! suppliers or licensors in any way.
!===============================================================================

!  Content:
!    vzConj  Example Program Text
!*******************************************************************************

      include "_rms.fi"

      program MKL_VML_TEST

      include "mkl_vml.f90"
      real(kind=4) :: srelerr
      real(kind=8) :: drelerr
      real(kind=4) :: crelerr
      real(kind=8) :: zrelerr

      complex(kind=8) zA(10)
      complex(kind=8) zB(10)
      complex(kind=8) zBha0(10)
      complex(kind=8) zBha1(10)
      complex(kind=8) zBha2(10)
      complex(kind=8) zBla1(10)
      complex(kind=8) zBla2(10)
      complex(kind=8) zBep1(10)
      complex(kind=8) zBep2(10)

      real(kind=8) CurRMS,MaxRMS

      integer(kind=8) mode
      integer tmode
      integer i, vec_len

      vec_len=10
      MaxRMS=0.0

      zA( 1)=(-100.0000d+000,100.0000d+000)
      zA( 2)=(-77.7777d+000,77.7777d+000)
      zA( 3)=(-55.5555d+000,55.5555d+000)
      zA( 4)=(-33.3333d+000,33.3333d+000)
      zA( 5)=(-11.1111d+000,11.1111d+000)
      zA( 6)=(11.1111d+000,-11.1111d+000)
      zA( 7)=(33.3333d+000,-33.3333d+000)
      zA( 8)=(55.5555d+000,-55.5555d+000)
      zA( 9)=(77.7777d+000,-77.7777d+000)
      zA(10)=(100.0000d+000,-100.0000d+000)
      zB( 1)=(-1.0000000000000000d+002,-1.0000000000000000d+002)
      zB( 2)=(-7.7777699999999996d+001,-7.7777699999999996d+001)
      zB( 3)=(-5.5555500000000002d+001,-5.5555500000000002d+001)
      zB( 4)=(-3.3333300000000001d+001,-3.3333300000000001d+001)
      zB( 5)=(-1.1111100000000000d+001,-1.1111100000000000d+001)
      zB( 6)=(1.1111100000000000d+001,1.1111100000000000d+001)
      zB( 7)=(3.3333300000000001d+001,3.3333300000000001d+001)
      zB( 8)=(5.5555500000000002d+001,5.5555500000000002d+001)
      zB( 9)=(7.7777699999999996d+001,7.7777699999999996d+001)
      zB(10)=(1.0000000000000000d+002,1.0000000000000000d+002)

      call VZCONJ(vec_len,zA,zBha0)

      mode=VML_EP
      call VMZCONJ(vec_len,zA,zBep1,mode)

      tmode=VML_EP
      tmode=VMLSETMODE(tmode)
      call VZCONJ(vec_len,zA,zBep2)

      mode=VML_LA
      call VMZCONJ(vec_len,zA,zBla1,mode)

      tmode=VML_LA
      tmode=VMLSETMODE(tmode)
      call VZCONJ(vec_len,zA,zBla2)

      mode=VML_HA
      call VMZCONJ(vec_len,zA,zBha1,mode)

      tmode=VML_HA
      tmode=VMLSETMODE(tmode)
      call VZCONJ(vec_len,zA,zBha2)

      do i=1,10
          if(zBha0(i) .ne. zBha1(i)) then
              print *,"Error! Difference between VZCONJ and"
              print *," VMZCONJ in VML_HA mode detected"
              stop 1
          endif
          if(zBha1(i) .ne. zBha2(i)) then
              print *,"Error! Difference between VZCONJ and"
              print *," VMZCONJ in VML_HA mode detected"
              stop 1
          endif
          if(zBla1(i) .ne. zBla2(i)) then
              print *,"Error! Difference between VZCONJ and"
              print *," VMZCONJ in VML_LA mode detected"
              stop 1
          endif
          if(zBep1(i) .ne. zBep2(i)) then
              print *,"Error! Difference between VZCONJ and"
              print *," VMZCONJ in VML_EP mode detected"
              stop 1
          endif
      end do

      print *,"vzConj test/example program"
      print *,""
      print *,"           Argument                     vzConj"
      print *,"======================================================", &
     &        "========================"
      do i=1,vec_len
            print 10,zA(i),"    ",zBha0(i)
            CurRMS=zrelerr(zB(i),zBha0(i))
            if(CurRMS>MaxRMS) MaxRMS=CurRMS
      end do

      print *,""
      if(MaxRMS>=1e-14) then
            print 11,"Error! Relative accuracy is ",MaxRMS
            stop 1
      else
            print 11,"Relative accuracy is ",MaxRMS
      endif

10    format(E15.7,E15.7,A5,E15.7,E15.7)
11    format(A,F25.16)

      end
